                processor 6502
                include "vcs.h"
                include "macro.h"


                SEG.U vars
                ORG $80

SpriteXPosition ds 1
				
     
                SEG code
                ORG $F800

Reset
   ; Clear RAM and all TIA registers

                ldx #0 
                lda #0 

Clear           sta 0,x 
                inx 
                bne Clear
       ;------------------------------------------------
       ; Once-only initialisation...
                lda #$c8
                sta COLUPF             ; set the playfield colour

                lda #$0e
                sta COLUBK             ; set the playfield colour

EyeDots:
				lda #2
				sta ENAM1  ;enable it
				lda #$9a
				sta COLUP1 ;color it [actually setting player 1 color, which missile 1 matches]
             
				lda #$20
				sta NUSIZ1	;make it quadwidth (not so thin, that)			 
				
StartOfFrame:
                lda #2
                sta WSYNC   ; ADDED
                sta VSYNC	
                sta WSYNC
                sta WSYNC
                lda #0      ; MOVED
                sta WSYNC               ; 3 scanlines of VSYNC signal
                sta VSYNC            

                ldx #0                 ; this counts our scanline number



VerticalBlank:
                sta WSYNC
                inx
                cpx #17
                bne VerticalBlank

                lda #0
                sta VBLANK   
				
				
				
				
Picture: 
                sta WSYNC
      
                lda #0
                sta PF1

                SLEEP 12

EyeDot:
				SLEEP 12	; 20 cycle delay
				sta RESM1	; reset missile1 position


                inx
                cpx #50        ; are we at line 
                bne Picture  ; No, so do another

				





Forehead:
	            sta WSYNC              ; wait till end of scanline

                lda #%01111100
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
		
				lda #0
				sta PF1
			
                inx
                cpx #54
                bne Forehead
	


			
Eyes:

				lda #2
				sta ENAM1  ;enable it

	            sta WSYNC              ; wait till end of scanline
				
                lda #%01100100
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
				
				lda #0
				sta PF1
			
                inx
                cpx #62
                bne Eyes	

				lda #0
				sta ENAM1  ;enable it


Middlehead:
	            sta WSYNC              ; wait till end of scanline

                lda #%01111100
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
		
				lda #0
				sta PF1
			
                inx
                cpx #66
                bne Middlehead

Nose:
	            sta WSYNC              ; wait till end of scanline

                lda #%01111111
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
		
				lda #0
				sta PF1
			
                inx
                cpx #74
                bne Nose

UpperMouth:
	            sta WSYNC              ; wait till end of scanline

                lda #%01011100
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
	
				lda #0
				sta PF1
			
                inx
                cpx #78
                bne UpperMouth

LowerMouth:
	            sta WSYNC              ; wait till end of scanline

                lda #%01100000
                sta PF1

                lda #0
                sta PF2      
                sta PF0

                SLEEP 28
	
				lda #0
				sta PF1
			
                inx
                cpx #82
                bne LowerMouth

Celery:    
	            sta WSYNC              ; wait till end of scanline

                lda #%01111100
                sta PF1

                lda #0
                sta PF2      

                SLEEP 22

                lda #0
                sta PF0

                SLEEP 8
	
				lda #0
				sta PF1
			
                inx
                cpx #192
                bne Celery
		
   ; 30 scanlines of overscan...
                ldx #0

Overscan:     
				sta WSYNC

                inx
                cpx #66
                bne Overscan
		
			    lda #2
                sta VBLANK          ; end of screen - enter blanking	
		
                jmp StartOfFrame

            ORG $FFFA

InterruptVectors
            .word Reset          ; NMI
            .word Reset          ; RESET
            .word Reset          ; IRQ

      END
